<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb620cb4ae090d06_04398805/operators/FlowchartOperator_lb620cb4ae090d06_04398805.php';

class SaveEntityOperator_lb620cb4ae090d06_04398805 extends FlowchartOperator_lb620cb4ae090d06_04398805{

    protected $entity;

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPortById($id, $value){
        if(!empty($this->inDataPorts[$id])){
            if($id == 'entity')
                $this->entity = $value;
        }
    }

    public function process($params = array()){
        if($this->entity instanceof SugarBean){

            if(method_exists($this->entity, 'setProducedFlowchartData')){
                $this->entity->setProducedFlowchartData(array('name' => $params['flowName']));
            }

            if(!$this->entity->new_with_id)
                $this->entity->save($this->checkNotifies());
        }
    }

    public function getOutDataByPortId($portId){
        if($portId == 'entity')
            return $this->entity;
        return $this->outDataPorts[$portId]['value'];
    }

    protected function isEntityInBlackList(){
        return !in_array($this->entity->module_name, array('Notifications'));
    }

    protected function checkNotifyUser(){
        global $current_user;
        return !empty($this->entity->assigned_user_id) &&
        $this->entity->assigned_user_id != $this->entity->fetched_row['assigned_user_id'] &&
        $current_user->id != $this->entity->assigned_user_id;
    }

    protected function checkNotifies(){
        return $this->isEntityInBlackList() && $this->checkNotifyUser();
    }

}
